# include <QtGui>

# include "smallffmpeggui.h"

smallffmpeggui::smallffmpeggui(QWidget *parent): QDialog(parent)
{
	setupUi(this);

	QTextCodec::setCodecForTr(QTextCodec::codecForName("UTF-8"));

	QTimer::singleShot(0, this, SLOT(ffmpegtest()));

	connect(convertButton, SIGNAL(clicked()), this, SLOT(konvertiere()));
	connect(cancelButton, SIGNAL(clicked()), this, SLOT(abgebrochen()));
	connect(closeButton, SIGNAL(clicked()), this, SLOT(close()));

	connect(openButton, SIGNAL(clicked()), this, SLOT(openDialog()));
	connect(saveButton, SIGNAL(clicked()), this, SLOT(saveDialog()));

	connect(&proc, SIGNAL(readyReadStandardError()), this, SLOT(updateprocbar()));
	connect(&proc, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(procbeendet(int, QProcess::ExitStatus)));
	connect(&proc, SIGNAL(error(QProcess::ProcessError)), this, SLOT(processError(QProcess::ProcessError)));

	connect(vcodecComboBox, SIGNAL(currentIndexChanged(int)), this, SLOT(changeendung()));
	connect(inputEdit, SIGNAL(textChanged(const QString &)), this, SLOT(changeendung()));

	connect(vcodecComboBox, SIGNAL(activated(int)), this, SLOT(vcopywahl()));
	connect(acodecComboBox, SIGNAL(currentIndexChanged(int)), this, SLOT(acopywahl()));
	connect(dvdButton, SIGNAL(clicked()), this, SLOT(dvdwahl()));

}

void smallffmpeggui::openDialog()
{
	QString initialName = inputEdit->text();
	if(initialName.isEmpty())
		initialName = QDir::homePath();

	QString InpFile = QFileDialog::getOpenFileName(
		this,
		"Open File Dialog",
		initialName,
		"video (*.avi *.mpg *.mpeg *.flv *.wmv *.mp4 *.mov);;All Files(*.*)");

	QString outputFile = outputEdit->text();

	if(!InpFile.isEmpty())
		{
		inputEdit->setText(InpFile);

		if(outputFile.isEmpty())
			{
			outputFile = QFileInfo(InpFile).absolutePath()+QDir::separator() 
					+ QFileInfo(InpFile).completeBaseName();

			if(vcodecComboBox->currentIndex()==0)
				{
				outputFile += ".";
				outputFile += QFileInfo(InpFile).suffix();
				}
			else
				{
				if(vcodecComboBox->currentIndex()==1 || vcodecComboBox->currentIndex()==2)
					{
					outputFile += ".avi";
					}
				else if(vcodecComboBox->currentIndex()==3 || vcodecComboBox->currentIndex()==4)
					{
					outputFile +=".mpg";
					}
				else if(vcodecComboBox->currentIndex()==5)
					{
					outputFile +=".mp4";
					}
				else if(vcodecComboBox->currentIndex()==6)
					{
					outputFile +=".flv";
					}
				}
			if(InpFile==outputFile)
				{
				outputFile.insert(outputFile.indexOf(QFileInfo(outputFile).suffix())-1, QString("-Kopie"));
				}
			outputEdit->setText(outputFile);
			}
		convertButton->setEnabled(true);
		}
}

void smallffmpeggui::saveDialog()
{
	QString InpFile = inputEdit->text();
	QString initialName = outputEdit->text();
	if(initialName.isEmpty())
		initialName = QDir::homePath();

	QString outputFile = QFileDialog::getSaveFileName(
		this,
		"Save File Dialog",
		initialName,
		"video (*.avi *.mpg *.mpeg *.flv *.wmv *.mp4 *.mov);;All Files(*.*)");

	if(!outputFile.isEmpty())
		{
		if(!InpFile.isEmpty())
			{
			outputFile = QFileInfo(outputFile).absolutePath() + QDir::separator() + QFileInfo(outputFile).completeBaseName();

			if(vcodecComboBox->currentIndex()==0)
				{
				outputFile += ".";
				outputFile += QFileInfo(inputEdit->text()).suffix();
				}
			else
				{
				if(vcodecComboBox->currentIndex()==1 || vcodecComboBox->currentIndex()==2)
					{
					outputFile += ".avi";
					}
				else if(vcodecComboBox->currentIndex()==3 || vcodecComboBox->currentIndex()==4)
					{
					outputFile +=".mpg";
					}
				else if(vcodecComboBox->currentIndex()==5)
					{
					outputFile +=".mp4";
					}
				else if(vcodecComboBox->currentIndex()==6)
					{
					outputFile +=".flv";
					}
				}
			}
		if(InpFile==outputFile)
			{
			outputFile.insert(outputFile.indexOf(QFileInfo(outputFile).suffix())-1, QString("-Kopie"));
			}
		outputEdit->setText(outputFile);
		}
}

void smallffmpeggui::changeendung()
{
	QString InpFile = inputEdit->text();
	QString outputFile = outputEdit->text();
	QString Kopie = "-Kopie";

	if(!outputFile.isEmpty())
		{
		if(outputFile.contains(Kopie))
			outputFile.remove(outputFile.indexOf(Kopie), Kopie.size());

		QString inputFileEnd = QFileInfo(inputEdit->text()).suffix();
		outputFile = QFileInfo(outputFile).absolutePath()+QDir::separator() 
			+ QFileInfo(outputFile).completeBaseName();

		if(vcodecComboBox->currentIndex()==0)
			{
			outputFile += ".";
			outputFile += inputFileEnd;
			}
		else
			{
			if(vcodecComboBox->currentIndex()==1 || vcodecComboBox->currentIndex()==2)
				{
				outputFile += ".avi";
				}
			else if(vcodecComboBox->currentIndex()==3 || vcodecComboBox->currentIndex()==4)
				{
				outputFile +=".mpg";
				}
			else if(vcodecComboBox->currentIndex()==5)
				{
				outputFile +=".mp4";
				}
			else if(vcodecComboBox->currentIndex()==6)
				{
				outputFile +=".flv";
				}
			}
		if(InpFile==outputFile)
			{
			outputFile.insert(outputFile.indexOf(QFileInfo(outputFile).suffix())-1, QString("-Kopie"));
			}
		outputEdit->setText(outputFile);
		}
}

void smallffmpeggui::konvertiere()
{
	progressBar->setValue(0);
	lcdNumber->display("0");

	QString inputFile=inputEdit->text();
	QString targetFile=outputEdit->text();
	QString ratioout=ratioComboBox->currentText();
	QString vbitrout=vbitrateSpinBox->text()+"k";
	QString aufloesung=(vauflspinBox->text())+"x"+(hauflspinBox->text());
	QString vcodecout=vcodecComboBox->currentText();
	QString framesout=fpsComboBox->currentText();
	QString acodecout=acodecComboBox->currentText();
	QString abitrateout=abitrateComboBox->currentText();
	QString konvbefausg;

	faktor=framesout.toDouble();

	QStringList args;
	args << "-y" << "-i" << inputFile;

	convertButton->setEnabled(false);
	befehlEdit->clear();
	progressEdit->clear();

	if (vcodecComboBox->currentIndex()==0)
        	{
		args << "-vcodec";
		args << "copy";
		}
	else
		{
		if(dvdButton->isChecked())
			{
			args << "-target" << "pal-dvd";
			args << "-aspect" << ratioout;
			args << "-b" << vbitrout;
			}
		else
			{
			args << "-s" << aufloesung;
			args << "-vcodec" << vcodecout;
			args << "-r" << framesout;
			args << "-aspect" << ratioout;
			args << "-b" << vbitrout;
			}
		}

	if (acodecComboBox->currentIndex()==0)
		{
		args << "-acodec" << "copy";
		}
	else if (acodecComboBox->currentIndex()==1)
		{
		args << "-acodec" << "pcm_s16le";
		}
	else if (acodecComboBox->currentIndex()==2)
		{
		args << "-acodec" << "libmp3lame";
		}
	else
		{
		args << "-acodec" << acodecout;
		}

	if (abitrateComboBox->isEnabled())
		{
		args << "-ab" << abitrateout;
		}

	if (channelButtonGroup->isEnabled())
		{
		args << "-ac";
		if (stereoButton->isChecked())
			{
			args << "2";
			}
		else
			{
			args << "1";
			}
		}

	args << targetFile;

	konvbefausg=args.join(" ");
	konvbefausg="ffmpeg "+konvbefausg;
	befehlEdit->setText(konvbefausg);

	proc.start("ffmpeg", args);

}

void smallffmpeggui::updateprocbar()
{	
	QByteArray data= proc.readAllStandardError();
	stdausgabe= QString::fromLocal8Bit(data);

	if(stdausgabe.contains("Duration:"))
		firsttime=1;
	
	if(firsttime==1)
	{
	QRegExp reg("..:..:..\\...");
	if(stdausgabe.contains(reg))
		{
		QString time=reg.cap();

		QString stunde=time.mid(0,2);
		QString minute=time.mid(3,2);
		QString sekunde=time.mid(6,5);

		double std=stunde.toDouble();
		double min=minute.toDouble();
		double sek=sekunde.toDouble();

		gesamtzeit=(std*3600)+(min*60)+sek;
		firsttime=0;
		}
	}

	QRegExp regtime("time=..:..:..\\...");
	if(stdausgabe.contains(regtime))
		{
		int posakt=stdausgabe.indexOf("time");
		QString aktzeit=stdausgabe.mid(posakt+5,11);
		QString akt_std=aktzeit.mid(0,2);
		QString akt_min=aktzeit.mid(3,2);
		QString akt_sek=aktzeit.mid(6);

		double tmp_std,tmp_min,tmp_sek;
		tmp_std=akt_std.toDouble();
		tmp_min=akt_min.toDouble();
		tmp_sek=akt_sek.toDouble();

		aktPosSek=(tmp_std*60*60)+(tmp_min*60)+tmp_sek;

		proz=aktPosSek*100/gesamtzeit;

		stdausgabe.chop(1);
		progressEdit->setText(stdausgabe);
		progressBar->setValue(proz);
		}

	else if(stdausgabe.contains("time"))
		{
		int posakt=stdausgabe.indexOf("time");
		QString aktzeit=stdausgabe.mid(posakt+5,5);
		aktPosSek=aktzeit.toDouble();
		proz=aktPosSek*100/gesamtzeit;

		stdausgabe.chop(1);
		progressEdit->setText(stdausgabe);
		progressBar->setValue(proz);
		}

	if(stdausgabe.contains("fps"))
		{
		int posframe=stdausgabe.indexOf("fps");
		QString framezahl=stdausgabe.mid(posframe+4,3);
		double framerate=framezahl.toDouble();

		if(framerate!=0)
			{
			double gesamtframes=gesamtzeit*faktor;
			double restframes=gesamtframes-(aktPosSek*faktor);
	
			double restsekunden=restframes/framerate;
			double tmp=restsekunden/60.0;
			int lcdmin=(int)tmp;
			int lcdsek=(int)restsekunden-(lcdmin*60);
	
			QString strmin;
			strmin.setNum(lcdmin);
			QString strsek;
			strsek.setNum(lcdsek);
			if(strsek.length()==1)
				strsek="0"+strsek;
	
			QString timerwert=strmin+":"+strsek;

			lcdNumber->display(timerwert);
			}
		}

}

void smallffmpeggui::procbeendet(int exitCode, QProcess::ExitStatus exitStatus)
{
	if (exitStatus==QProcess::CrashExit)
		{
		progressEdit->setText(tr("CONVERSION CRASHED!!!"));
		}
	else if(exitCode==1)
		{
		lcdNumber->display("ERROR");
		progressEdit->setText(tr("FEHLER beim Konvertierungsstart!!!"));
		font.setPointSize(12);
		QMessageBox msgBox;
		msgBox.setStandardButtons(QMessageBox::Ok);
		msgBox.setFont(font);
		msgBox.setIcon(QMessageBox::Critical);
		msgBox.setWindowTitle("small-ffmpeg-gui Fehler");
		msgBox.setText(tr("<b>ffmpeg meldete einen Fehler!</b><br><br>"
			"Bitte überprüfen sie die Einstellungen für die Umwandlung <br>"
			"anhand der Fehlerbeschreibung in den Details.<br>"));
		msgBox.setDetailedText(stdausgabe);
		msgBox.exec();
		}
	else if(exitCode==255)
		{
		progressEdit->setText(tr("Konvertierung ABGEBROCHEN!!!"));
		}
	else 
		{
		progressEdit->setText(tr("Konvertierung beendet!"));
		progressBar->setValue(100);
		}

	convertButton->setEnabled(true);
}

void smallffmpeggui::processError(QProcess::ProcessError error)
{
	if(error==QProcess::FailedToStart)
		{
		progressEdit->setText(tr("FEHLER beim Starten der Konvertierung!!!"));
		convertButton->setEnabled(true);
		}
}

void smallffmpeggui::abgebrochen()
{
	proc.terminate();
	convertButton->setEnabled(true);
}

void smallffmpeggui::vcopywahl()
{
	if (vcodecComboBox->currentIndex()==0)
		{
		vauflspinBox->setEnabled(false);
		hauflspinBox->setEnabled(false);
		ratioComboBox->setEnabled(false);
		vbitrateSpinBox->setEnabled(false);
		fpsComboBox->setEnabled(false);
		}
	else
		{
		vauflspinBox->setEnabled(true);
		hauflspinBox->setEnabled(true);
		ratioComboBox->setEnabled(true);
		vbitrateSpinBox->setEnabled(true);
		fpsComboBox->setEnabled(true);
		}
}

void smallffmpeggui::dvdwahl()
{
	if (dvdButton->isChecked())
		{
		vauflspinBox->setEnabled(false);
		vauflspinBox->setValue(720);
		hauflspinBox->setEnabled(false);
		hauflspinBox->setValue(576);
		vcodecComboBox->setEnabled(false);
		vcodecComboBox->setCurrentIndex(4);
		ratioComboBox->setEnabled(true);
		vbitrateSpinBox->setEnabled(true);
		fpsComboBox->setEnabled(false);
		fpsComboBox->setCurrentIndex(1);
		acodecComboBox->setCurrentIndex(4);
		abitrateComboBox->setEnabled(true);
		channelButtonGroup->setEnabled(true);
		}
	else
		{
		vauflspinBox->setEnabled(true);
		hauflspinBox->setEnabled(true);
		vcodecComboBox->setEnabled(true);
		fpsComboBox->setEnabled(true);
		}
}

void smallffmpeggui::acopywahl()
{
	if (acodecComboBox->currentIndex()==0)
		{
		abitrateComboBox->setEnabled(false);
		channelButtonGroup->setEnabled(false);
		}
	else if(acodecComboBox->currentIndex()==1)
		{
		abitrateComboBox->setEnabled(false);
		channelButtonGroup->setEnabled(true);
		}
	else
		{
		abitrateComboBox->setEnabled(true);
		channelButtonGroup->setEnabled(true);
		}
}


// Test nach dem Starten ob ffmpeg verfügbar, wenn nicht mit QMessageBox beenden

void smallffmpeggui::ffmpegtest()
{
	QFileInfo test("/usr/bin/ffmpeg");
	if(!test.exists())
		{
		font.setPointSize(12);
		QMessageBox msgBox;
		msgBox.setStandardButtons(QMessageBox::Ok);
		msgBox.setFont(font);
		msgBox.setIcon(QMessageBox::Critical);
		msgBox.setWindowTitle("small-ffmpeg-gui Fehler");
		msgBox.setText(tr("<b>Fehler: ffmpeg nicht gefunden!</b><br><br>"
			"small-ffmpeg-gui benötigt für den Betrieb<br>"
			"das Programm ffmpeg.<br>"
			"Bitte installieren Sie die Anwendung mit<br>"
			"<b>apt-get install ffmpeg</b>.<br>"
			"small-ffmpeg-gui wird geschlossen."));
		msgBox.exec();
		QCoreApplication::exit(2);
		}
}

